﻿Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Try
            SerialPort1.Open() 'ポートを接続する
        Catch ex As Exception
            MessageBox.Show("COMポートが接続できませんでした")
            Close()
        End Try
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim Cmd() As Byte 'コマンドを送信するための配列
        Dim Rx(4) As Byte 'コマンド送信後にB3Mから返るデータを受け取る（受け取りデータ数は5Byte）

        Cmd = B3MLib.B3MLib.WriteSingle(
            0,
            B3MLib.B3MLib.SERVO_TORQUE_ON,
            0,
            New Byte() {
            CType(B3MLib.B3MLib.Options.RunNormal, Byte) Or
            CType(B3MLib.B3MLib.Options.ControlPosition, Byte)})

        'オプション: 0
        '書き込みアドレス: B3MLib.B3MLib.SERVO_TORQUE_ON
        'ID: 0
        '書き込みデータ: ノーマル位置制御モードにする

        '作成したコマンドを送信し失敗したらエラーメッセージを出す
        If B3MLib.B3MLib.Synchronize(SerialPort1, Cmd, Rx) = False Then
            MessageBox.Show("コマンドの送信に失敗しました")
        End If

    End Sub

    Private Sub TrackBar1_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar1.Scroll
        Dim Cmd() As Byte 'コマンドを送信するための配列
        Dim Rx(4) As Byte 'コマンド送信後にB3Mから返るデータを受け取る（受け取りデータ数は5Byte）

        Cmd = B3MLib.B3MLib.WriteSingle(
            0,
            B3MLib.B3MLib.SERVO_DESIRED_POSITION,
            0,
            Extensions.Converter.ByteConverter.Int16ToByteArray(TrackBar1.Value))

        'オプション: 0
        '書き込みアドレス: B3MLib.B3MLib.SERVO_DESIRED_POSITION
        'ID: 0
        '書き込みデータ: 目標位置（TrackBar1.Value）

        '作成したコマンドを送信し失敗したらもう一度送信する
        If B3MLib.B3MLib.Synchronize(SerialPort1, Cmd, Rx) = False Then
            'B3MLib.B3MLib.Synchronize(SerialPort1, Cmd, Rx)
            MessageBox.Show("コマンドの送信に失敗しました")
        End If

    End Sub
End Class
